{ NonVisual Component for Lazarus }

unit Formpos;

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, Forms;

type

{ TFormPos }

TFormPos = class(TComponent)

   private
    FPosList : TStringList;
    FFilename: String;
    FPath: string;
    procedure SetFilename(const Value: string);
    procedure SetPath(const Value: string);
    procedure AlignScreen(Form: TCustomForm);
   
   public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SavePosition(Form: TCustomForm);
    function RestorePosition(Form: TCustomForm):Boolean;
    
   published
    property Filename: string read FFilename write SetFilename;
    property Path: string read FPath write SetPath;
   end;

implementation

constructor TFormPos.create(AOwner: TComponent);
begin
      inherited create(AOwner);
end;

destructor TFormPos.Destroy;
begin
      inherited Destroy;
end;

procedure TFormPos.SetFilename(const Value: string);
begin
     FFilename:= Value;
end;

procedure TFormPos.SetPath(Const Value: string);
begin
      FPath:= Value;
end;

procedure TFormPos.AlignScreen(Form: TCustomForm);
begin
    if Form.Top < 0 then Form.Top:=0;
    if Form.Left < 0 then Form.Left:=0;
    if Form.Height > Screen.Height then Form.Height:= Screen.Height;
    if Form.Width > Screen.Width then Form.Width:= Screen.Width;
end;

procedure TFormPos.SavePosition(Form: TCustomForm);
begin
    FPosList:= TStringList.Create;
    AlignScreen(Form);
    FPosList.Add(IntToStr(Form.Top));
    FPosList.Add(IntToStr(Form.Left));
    FPosList.Add(IntToStr(Form.Height));
    FPosList.Add(IntToStr(Form.Width));
    FPosList.SaveToFile(FFilename);
    FPosList.Free;
end;

function TFormPos.RestorePosition(Form: TCustomForm):Boolean;
begin
Result:= False;
   if FileExists(FFileName) then begin
     FPosList:= TStringList.Create;
     FPosList.LoadFromFile(FFilename);
     Form.Top:= StrToInt(FPosList[0]);
     Form.Left:= StrToInt(FPosList[1]);
     Form.Height:= StrToInt(FPosList[2]);
     Form.Width:= StrToInt(FPosList[3]);
     FPosList.Free;
     Result:= True;
     end;
end;

end.

